Bug 177693 - www/apache24 doesn't build on sparc64
Summary: www/apache24 doesn't build on sparc64
Status: Closed FIXED
Alias: None
Product: Ports & Packages
Classification: Unclassified
Component: Individual Port(s) (show other bugs)
Version: Latest
Hardware: Any Any
: Normal Affects Only Me
Assignee: freebsd-apache mailing list
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-04-07 18:20 UTC by Michael Moll
Modified: 2013-04-20 18:40 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Moll freebsd_committer 2013-04-07 18:20:00 UTC
See usptream bug:
https://issues.apache.org/bugzilla/show_bug.cgi?id=52900

Fix: 

I used the workaround from the upstream bug report. Maybe this could be applied as a patch to the port when building on sparc64.
How-To-Repeat: build www/apache24 on a sparc64 machine
Comment 1 Edwin Groothuis freebsd_committer 2013-04-07 18:20:09 UTC
Responsible Changed
From-To: freebsd-ports-bugs->apache

Over to maintainer (via the GNATS Auto Assign Tool)
Comment 2 dfilter service freebsd_committer 2013-04-20 18:28:50 UTC
Author: ohauer
Date: Sat Apr 20 17:28:36 2013
New Revision: 316160
URL: http://svnweb.freebsd.org/changeset/ports/316160

Log:
  - fix build on sparc64 machine
  
  Feature safe: yes
  
  with hat apache@
  
  PR:		177693
  Submitted by:	Michael Moll <kvedulv@kvedulv.de>
  Obtained from:	http://svn.apache.org/viewvc?view=revision&revision=1470183

Added:
  head/www/apache24/files/patch-server__core.c   (contents, props changed)
Modified:
  head/www/apache24/Makefile

Modified: head/www/apache24/Makefile
==============================================================================
--- head/www/apache24/Makefile	Sat Apr 20 16:29:57 2013	(r316159)
+++ head/www/apache24/Makefile	Sat Apr 20 17:28:36 2013	(r316160)
@@ -2,6 +2,7 @@
 
 PORTNAME=	apache24
 PORTVERSION=	2.4.4
+PORTREVISION=	1
 CATEGORIES=	www ipv6
 MASTER_SITES=	${MASTER_SITE_APACHE_HTTPD}
 DISTNAME=	httpd-${PORTVERSION}

Added: head/www/apache24/files/patch-server__core.c
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/www/apache24/files/patch-server__core.c	Sat Apr 20 17:28:36 2013	(r316160)
@@ -0,0 +1,27 @@
+Apache issue: https://issues.apache.org/bugzilla/show_bug.cgi?id=52900
+
+Obtained from:
+http://svn.apache.org/viewvc?view=revision&revision=1470183
+============================================================
+--- ./server/core.c.orig	2013-02-06 18:15:16.000000000 +0100
++++ ./server/core.c	2013-04-20 19:11:17.000000000 +0200
+@@ -4768,13 +4768,18 @@
+ AP_DECLARE(apr_uint32_t) ap_random_pick(apr_uint32_t min, apr_uint32_t max)
+ {
+     apr_uint32_t number;
++#if (!__GNUC__ || __GNUC__ >= 5 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 8) || \
++     !__sparc__ || APR_SIZEOF_VOIDP != 8)
++    /* This triggers a gcc bug on sparc/64bit with gcc < 4.8, PR 52900 */
+     if (max < 16384) {
+         apr_uint16_t num16;
+         ap_random_insecure_bytes(&num16, sizeof(num16));
+         RAND_RANGE(num16, min, max, APR_UINT16_MAX);
+         number = num16;
+     }
+-    else {
++    else
++#endif
++    {
+         ap_random_insecure_bytes(&number, sizeof(number));
+         RAND_RANGE(number, min, max, APR_UINT32_MAX);
+     }
_______________________________________________
svn-ports-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/svn-ports-all
To unsubscribe, send any mail to "svn-ports-all-unsubscribe@freebsd.org"
Comment 3 Olli Hauer freebsd_committer 2013-04-20 18:29:18 UTC
State Changed
From-To: open->closed

Thanks for the report! 

I've added the patch from 
http://svn.apache.org/viewvc?view=revision&revision=1470183